<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Smart Folder: Référence du fichier src/list.c</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Smart Folder
   &#160;<span id="projectnumber">0.1</span>
   </div>
   <div id="projectbrief">Un répertoire virtuel de recherche de fichiers</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Généré par Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Recherche');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Recherche');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('list_8c.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#func-members">Fonctions</a>  </div>
  <div class="headertitle">
<div class="title">Référence du fichier list.c</div>  </div>
</div><!--header-->
<div class="contents">

<p>Contient les fonctions pour gérer une liste chainée.  
<a href="#details">Plus de détails...</a></p>
<div class="textblock"><code>#include &lt;stdlib.h&gt;</code><br />
<code>#include &lt;stdio.h&gt;</code><br />
<code>#include &quot;<a class="el" href="list_8h_source.html">../inc/list.h</a>&quot;</code><br />
<code>#include &quot;<a class="el" href="logger_8h_source.html">../inc/logger.h</a>&quot;</code><br />
</div><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Fonctions</h2></td></tr>
<tr class="memitem:aaf19d730cd21bbfe036aaf5d39f641f6"><td class="memItemLeft" align="right" valign="top"><a class="el" href="structnode__t.html">node_t</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="list_8c.html#aaf19d730cd21bbfe036aaf5d39f641f6">new_list</a> ()</td></tr>
<tr class="memdesc:aaf19d730cd21bbfe036aaf5d39f641f6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Création d'une nouvelle liste vide.  <a href="#aaf19d730cd21bbfe036aaf5d39f641f6">Plus de détails...</a><br /></td></tr>
<tr class="separator:aaf19d730cd21bbfe036aaf5d39f641f6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2470dc01cbfccd978242c9aa5fff1217"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="list_8c.html#a2470dc01cbfccd978242c9aa5fff1217">is_empty</a> (<a class="el" href="structnode__t.html">node_t</a> *list)</td></tr>
<tr class="memdesc:a2470dc01cbfccd978242c9aa5fff1217"><td class="mdescLeft">&#160;</td><td class="mdescRight">Vérifier si une liste est vide.  <a href="#a2470dc01cbfccd978242c9aa5fff1217">Plus de détails...</a><br /></td></tr>
<tr class="separator:a2470dc01cbfccd978242c9aa5fff1217"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afd9fffaa9cb079406050bfb4dfb062ff"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="list_8c.html#afd9fffaa9cb079406050bfb4dfb062ff">insert_head</a> (<a class="el" href="structnode__t.html">node_t</a> **list, void *data)</td></tr>
<tr class="memdesc:afd9fffaa9cb079406050bfb4dfb062ff"><td class="mdescLeft">&#160;</td><td class="mdescRight">Insertion d'un élément à la tête de la liste.  <a href="#afd9fffaa9cb079406050bfb4dfb062ff">Plus de détails...</a><br /></td></tr>
<tr class="separator:afd9fffaa9cb079406050bfb4dfb062ff"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a892dd296a519b13603b2261285357b47"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="list_8c.html#a892dd296a519b13603b2261285357b47">insert_tail</a> (<a class="el" href="structnode__t.html">node_t</a> **list, void *data)</td></tr>
<tr class="memdesc:a892dd296a519b13603b2261285357b47"><td class="mdescLeft">&#160;</td><td class="mdescRight">Insertion d'un élément à la queue de la liste.  <a href="#a892dd296a519b13603b2261285357b47">Plus de détails...</a><br /></td></tr>
<tr class="separator:a892dd296a519b13603b2261285357b47"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab931a1e780637e15a9ff7a681778fbbc"><td class="memItemLeft" align="right" valign="top"><a class="el" href="structnode__t.html">node_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="list_8c.html#ab931a1e780637e15a9ff7a681778fbbc">remove_node</a> (<a class="el" href="structnode__t.html">node_t</a> **list, unsigned int pos)</td></tr>
<tr class="memdesc:ab931a1e780637e15a9ff7a681778fbbc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Suppression de l'élément ayant la position <em>pos</em> de la liste.  <a href="#ab931a1e780637e15a9ff7a681778fbbc">Plus de détails...</a><br /></td></tr>
<tr class="separator:ab931a1e780637e15a9ff7a681778fbbc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a12def8678b9602312e57e290462c8ae0"><td class="memItemLeft" align="right" valign="top"><a class="el" href="structnode__t.html">node_t</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="list_8c.html#a12def8678b9602312e57e290462c8ae0">get_node</a> (<a class="el" href="structnode__t.html">node_t</a> *list, unsigned int pos)</td></tr>
<tr class="memdesc:a12def8678b9602312e57e290462c8ae0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Récupération de l'élément ayant la position <em>pos</em> à partir de la liste.  <a href="#a12def8678b9602312e57e290462c8ae0">Plus de détails...</a><br /></td></tr>
<tr class="separator:a12def8678b9602312e57e290462c8ae0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8ffe93a3beaf22d1d8cd6ee35beb1012"><td class="memItemLeft" align="right" valign="top">unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="list_8c.html#a8ffe93a3beaf22d1d8cd6ee35beb1012">size</a> (<a class="el" href="structnode__t.html">node_t</a> *list)</td></tr>
<tr class="memdesc:a8ffe93a3beaf22d1d8cd6ee35beb1012"><td class="mdescLeft">&#160;</td><td class="mdescRight">Calcul de la taille de la liste.  <a href="#a8ffe93a3beaf22d1d8cd6ee35beb1012">Plus de détails...</a><br /></td></tr>
<tr class="separator:a8ffe93a3beaf22d1d8cd6ee35beb1012"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa13b0ecb36f4cdbbc2f55e6b9cf1dd16"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="list_8c.html#aa13b0ecb36f4cdbbc2f55e6b9cf1dd16">free_list</a> (<a class="el" href="structnode__t.html">node_t</a> *list)</td></tr>
<tr class="memdesc:aa13b0ecb36f4cdbbc2f55e6b9cf1dd16"><td class="mdescLeft">&#160;</td><td class="mdescRight">Libération de la mémoire alouée par la liste.  <a href="#aa13b0ecb36f4cdbbc2f55e6b9cf1dd16">Plus de détails...</a><br /></td></tr>
<tr class="separator:aa13b0ecb36f4cdbbc2f55e6b9cf1dd16"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af6f6e7ea883c6a2e36a6bfc6dd653f23"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="list_8c.html#af6f6e7ea883c6a2e36a6bfc6dd653f23">print_list</a> (<a class="el" href="structnode__t.html">node_t</a> *list, void(*print)(void *arg))</td></tr>
<tr class="memdesc:af6f6e7ea883c6a2e36a6bfc6dd653f23"><td class="mdescLeft">&#160;</td><td class="mdescRight">Affichage de la liste sur la sortie standrad.  <a href="#af6f6e7ea883c6a2e36a6bfc6dd653f23">Plus de détails...</a><br /></td></tr>
<tr class="separator:af6f6e7ea883c6a2e36a6bfc6dd653f23"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Description détaillée</h2>
<div class="textblock"><p>Contient les fonctions pour gérer une liste chainée. </p>
<dl class="section author"><dt>Auteur</dt><dd>Abdennadher Raed &amp; Antoniadis Orphée </dd></dl>
<dl class="section version"><dt>Version</dt><dd>0.1 </dd></dl>
<dl class="section date"><dt>Date</dt><dd>27 janvier 2017 </dd></dl>
</div><h2 class="groupheader">Documentation des fonctions</h2>
<a id="aa13b0ecb36f4cdbbc2f55e6b9cf1dd16"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa13b0ecb36f4cdbbc2f55e6b9cf1dd16">&#9670;&nbsp;</a></span>free_list()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void free_list </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structnode__t.html">node_t</a> *&#160;</td>
          <td class="paramname"><em>list</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Libération de la mémoire alouée par la liste. </p>
<dl class="params"><dt>Paramètres</dt><dd>
  <table class="params">
    <tr><td class="paramname">list</td><td>Liste chainée </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a12def8678b9602312e57e290462c8ae0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a12def8678b9602312e57e290462c8ae0">&#9670;&nbsp;</a></span>get_node()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structnode__t.html">node_t</a>* get_node </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structnode__t.html">node_t</a> *&#160;</td>
          <td class="paramname"><em>list</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned int&#160;</td>
          <td class="paramname"><em>pos</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Récupération de l'élément ayant la position <em>pos</em> à partir de la liste. </p>
<dl class="params"><dt>Paramètres</dt><dd>
  <table class="params">
    <tr><td class="paramname">list</td><td>Liste chainée </td></tr>
    <tr><td class="paramname">pos</td><td>Position de l'élément à récupérer </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Renvoie</dt><dd>Pointeur sur le noeud trouvé si trouvé, NULL sinon </dd></dl>

</div>
</div>
<a id="afd9fffaa9cb079406050bfb4dfb062ff"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afd9fffaa9cb079406050bfb4dfb062ff">&#9670;&nbsp;</a></span>insert_head()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void insert_head </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structnode__t.html">node_t</a> **&#160;</td>
          <td class="paramname"><em>list</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>data</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Insertion d'un élément à la tête de la liste. </p>
<dl class="params"><dt>Paramètres</dt><dd>
  <table class="params">
    <tr><td class="paramname">list</td><td>Liste chainée </td></tr>
    <tr><td class="paramname">data</td><td>Elément à insérer </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a892dd296a519b13603b2261285357b47"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a892dd296a519b13603b2261285357b47">&#9670;&nbsp;</a></span>insert_tail()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void insert_tail </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structnode__t.html">node_t</a> **&#160;</td>
          <td class="paramname"><em>list</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>data</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Insertion d'un élément à la queue de la liste. </p>
<dl class="params"><dt>Paramètres</dt><dd>
  <table class="params">
    <tr><td class="paramname">list</td><td>Liste chainée </td></tr>
    <tr><td class="paramname">data</td><td>Elément à insérer </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a2470dc01cbfccd978242c9aa5fff1217"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2470dc01cbfccd978242c9aa5fff1217">&#9670;&nbsp;</a></span>is_empty()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int is_empty </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structnode__t.html">node_t</a> *&#160;</td>
          <td class="paramname"><em>list</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Vérifier si une liste est vide. </p>
<dl class="params"><dt>Paramètres</dt><dd>
  <table class="params">
    <tr><td class="paramname">list</td><td>Liste chainée à vérifier </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Renvoie</dt><dd><em>true</em> si la liste est vide, <em>false</em> sinon </dd></dl>

</div>
</div>
<a id="aaf19d730cd21bbfe036aaf5d39f641f6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aaf19d730cd21bbfe036aaf5d39f641f6">&#9670;&nbsp;</a></span>new_list()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structnode__t.html">node_t</a>* new_list </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Création d'une nouvelle liste vide. </p>
<dl class="section return"><dt>Renvoie</dt><dd>NULL </dd></dl>

</div>
</div>
<a id="af6f6e7ea883c6a2e36a6bfc6dd653f23"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af6f6e7ea883c6a2e36a6bfc6dd653f23">&#9670;&nbsp;</a></span>print_list()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void print_list </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structnode__t.html">node_t</a> *&#160;</td>
          <td class="paramname"><em>list</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void(*)(void *arg)&#160;</td>
          <td class="paramname"><em>print</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Affichage de la liste sur la sortie standrad. </p>
<dl class="params"><dt>Paramètres</dt><dd>
  <table class="params">
    <tr><td class="paramname">list</td><td>Liste chainée à afficher </td></tr>
    <tr><td class="paramname">print</td><td>Pointeur sur une fonction d'affichage </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ab931a1e780637e15a9ff7a681778fbbc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab931a1e780637e15a9ff7a681778fbbc">&#9670;&nbsp;</a></span>remove_node()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structnode__t.html">node_t</a> remove_node </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structnode__t.html">node_t</a> **&#160;</td>
          <td class="paramname"><em>list</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned int&#160;</td>
          <td class="paramname"><em>pos</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Suppression de l'élément ayant la position <em>pos</em> de la liste. </p>
<dl class="params"><dt>Paramètres</dt><dd>
  <table class="params">
    <tr><td class="paramname">list</td><td>Liste chainée </td></tr>
    <tr><td class="paramname">pos</td><td>Position de l'élément à supprimer </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Renvoie</dt><dd>Le noeud supprimé </dd></dl>

</div>
</div>
<a id="a8ffe93a3beaf22d1d8cd6ee35beb1012"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8ffe93a3beaf22d1d8cd6ee35beb1012">&#9670;&nbsp;</a></span>size()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned int size </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structnode__t.html">node_t</a> *&#160;</td>
          <td class="paramname"><em>list</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Calcul de la taille de la liste. </p>
<dl class="params"><dt>Paramètres</dt><dd>
  <table class="params">
    <tr><td class="paramname">list</td><td>Liste chainée </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Renvoie</dt><dd>La taille de la liste </dd></dl>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="list_8c.html">list.c</a></li>
    <li class="footer">Généré par
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.13 </li>
  </ul>
</div>
</body>
</html>
